var _contact_fields = [{"type": "string",
					     "value": "string",
					     "pref": "boolean"
					    }
			   ];
var _contact_properties = {"id": "opaquestring",
			   "displayName": "string",
			   "name": {"formatted": "string",
				    "familyName": "string",
				    "givenName": "string",
				    "middleName": "string",
				    "honorificPrefix": "string",
				    "honorificSuffix": "string"},
			   "nickname": "string",
			   "phoneNumbers": _contact_fields,
			   "emails": _contact_fields,
			   "addresses": [{
					     "pref": "boolean",
					     "type": "string",
					     "formatted": "string",
					     "streetAddress": "string",
					     "locality": "string",
					     "postalCode": "string",
					     "region": "string",
					     "streetAddress": "string"
					 }], 
			   "ims": _contact_fields,
			   "organizations": [{
						 "pref": "boolean",
						 "type": "string",
						 "name": "string",
						 "department": "string",
						 "title": "string"
					     }],
			   "revision": "date",
			   "birthday": "date",
			   "gender": "string",
			   "note": "string",
			   "photos": _contact_fields,
			   "categories": ["string"],
			   "urls": _contact_fields,
			   "timezone": "string"};

function assert_is_contact(actual) {
    for (var i in _contact_properties) {
	assert_own_property(actual, i);
    }
}

function assert_contact_same_as(actual, expected) {
    for (var field in _contact_properties) {
	_compare_field(actual[field], expected[field], field, _contact_properties[field]);
    }
}

function _compare_field(actual, expected, fieldname, datatype) {
    if (expected == null) {
	assert_equals(actual, expected, "Comparing values of " + fieldname);	
    } else if (datatype == "string" || datatype == "date" || datatype=="opaquestring") {
	if (expected == null || datatype != "opaquestring") {
	    assert_equals(actual, expected, "Comparing values of " + fieldname);
	}
    } else if (datatype instanceof Array) {
        for (var i in expected) {
	    _compare_field(actual[i], expected[i], fieldname, datatype[0]);
	}
    } else if (typeof(datatype)=='object') {
        for (var i in  actual) {
	    assert_own_property(expected, i, "Unexpected property " + i + " in " + fieldname);
            _compare_field(actual[i], expected[i], fieldname + "." + i, "string");
        }
	for (var j in expected) {
	    assert_own_property(actual, j, "Missing property " + j + " in " + fieldname);
	}
    } else {
	assert_unreached( "Unknown datatype to compare:" + datatype);		
    }
}
