(function (exports, $) {
    var curLocation = null, db, store;

    exports.UI = {
        loadEverything:    function () {
            Messaging.watchLocation();
            var idxdb = window.IndexedDB || window.mozIndexedDB || window.webkitIndexedDB,
                dbReq = idxdb.open("Unicorner");
            dbReq.onsuccess = function () {
                db = dbReq.result;
                var vReq = db.setVersion("1.0");
                vReq.onsuccess = function () {
                    try {
                        store = db.createObjectStore("messages", { keyPath: "id" });
                    }
                    catch (e) {}
                    Messaging.loadMessages(function (msgs) {
                        for (var i = 0, n = msgs.length; i < n; i++) {
                            UI.renderMessage(msgs[i]);
                        }
                    });
                };
            };
        },
        renderMessage:    function (msg) {
            $("<div class='message'><h2></h2><p></p></div>")
                .find("h2").html(msg.sender).append(" <span class='loc'>(" + msg.location + ")</span>").end()
                .find("p").html(msg.content).end()
                .appendTo($("#content"));
        }
    };

    exports.Messaging = {
        loadMessages:    function (cb) {
            $.getJSON("messages.json", function (data) {
                if (store) {
                    for (var i = 0, n = data.length; i < n; i++) store.add(data[i]);
                }
                cb(data);
            })
        },
        sendMessage:    function (txt) {
            var msg = {
                sender:     "@robunicorn",
                content:    txt,
                position:   curLocation
            };
            // imagine there's some sending going on here
        },
        watchLocation:    function () {
            navigator.geolocation
                     .watchPosition(function (pos) { curLocation = { latitude: pos.latitude, 
                                                                     longitude: pos.longitude };});
        },
    };
})(window, jQuery);
